/* 
make a linking library of the bulk of the Linux syscalls. 
see the section 2 intro seedoc. This uses the macros in unistd.h
to build syscalls. 
This may even be fairly portable.

Copyright 1999 Richard Allen Hohensee

errno needs to be declared. The other stuff just needs to be typed.
*/

#include <asm/unistd.h>
#include <linux/types.h>

int errno;


typedef struct {
        unsigned long sig[1];
} sigset_t;


struct Dummy {
	int first;
	};

struct Dummy1 {
	int first;
	};

struct Dummy2 {
	int first;
	};



/* 
_newselect
_sysctl
*/

_syscall5 ( int, _llseek, unsigned int, fd, unsigned long, ulong1,
	unsigned long, ulong2, loff_t *, llen, unsigned int, ufirst); 

_syscall2 (  int, access,  const char *, charbuf, int, first);

_syscall1 (  int, acct,  const char *, charbuf);

_syscall1 (  int, adjtimex,  struct Dummy *, dummy);

_syscall1 (  unsigned int, alarm,  unsigned int, ufirst);


_syscall2 (  int, bdflush,  int, first, long, lfirst);

_syscall1 (  int, brk,  void *, voidp);

/* 
capget
capset
*/

_syscall1 (  int, chdir,  const char *, charbuf);

_syscall2 (  int, chmod,  const char *, charbuf, mode_t, mode);

_syscall2 (  int, fchmod,  int, first, mode_t, mode);

_syscall3 (  int, chown,  const char *, charbuf, uid_t, owner, gid_t, group);

_syscall3 (  int, fchown,  int, first, uid_t, owner, gid_t, group);

_syscall3 (  int, lchown,  const char *,  path, uid_t, owner, gid_t, group);

_syscall1 (  int, chroot,  const char *, path);

_syscall4 ( int, clone, int, first, void *, voidp, int,
	second, void   *, voidp2);

_syscall1 (  int, close,  int, fd);

/*
create_module
delete_module
*/

_syscall2 (  int, creat,  const char *, path, mode_t, mode);

_syscall1 (  int, dup,  int, first);

_syscall2 (  int, dup2,  int, first, int, second);

_syscall3 ( int, execve , const char *, charbuf, char * const, argv , char
	* const, envp ); 

_syscall1 (  int, exit, int, first);

_syscall1 (  int, fchdir,  int, fd);

_syscall3 (  int, fcntl,  int, fd, int, second, struct Dummy  *, dummy);

_syscall1 (  int, fdatasync,  int, fd);

_syscall2 (  int, flock,  int, first, int, second);

_syscall0 (  pid_t, fork );

_syscall2 (  int, fstat,  int, first, struct Dummy *, dummy);

_syscall1 (  int, fsync,  int, fd);

/* 
getcwd			in unistd, no mention in man
get_kernel_syms		
*/

_syscall2  ( int, ftruncate,  int, fd, off_t, len);

_syscall3 ( int, getdents, unsigned int, ufirst, struct Dummy *, dummy,
unsigned int, usecond); 

_syscall0 (  gid_t, getegid );

_syscall0 (  uid_t, geteuid );

_syscall0 (  gid_t, getgid );

_syscall2 (  int, getgroups,  int, first, gid_t, group);

_syscall2 (  int, getitimer,  int, first, struct Dummy *, dummy);

_syscall0 (  pid_t, getpid );

_syscall0 (  pid_t, getppid );

_syscall1 (  pid_t, getpgid,  pid_t, pid);

_syscall2 (  int, getpriority,  int, first, int, second);

_syscall3 (  int, setpriority,  int, first, int, second, int, third);

_syscall3 (  int, getresuid,  uid_t *, first, uid_t *, second, uid_t *, third);

_syscall3 ( int, getresgid, gid_t *, first , gid_t *, second, gid_t *,
third); 

_syscall2 (  int, getrlimit ,  int, first, struct Dummy *, dummy);

_syscall2 (  int, getrusage ,  int, first, struct Dummy *, dummy);

_syscall1 (  pid_t, getsid,  pid_t, pid);

_syscall2 (  int, gettimeofday,  struct Dummy *, dummy, struct Dummy2 *,
 dummy2);

_syscall0 (  uid_t, getuid );


_syscall0 (  void, idle );

/*
init_module
*/

_syscall3 (  int, ioctl,  int, first, int, second, int, blah);

_syscall3 ( int, ioperm, unsigned long, ulong1, unsigned long, ulong2, int,
	first); 

_syscall1  (  int, iopl,  int, first);


/* this is a 6, and it's Linux-specific. 
_syscall5 ( int, ipc, 
unsigned int, ufirst, 
int, first, 
int, second, 
int, third, 
void *, voidp, 
long, lfirst); 
*/

_syscall2 (  int, kill,  pid_t, pid, int, first);

_syscall2 (  int, link,  const char *, charbuf, const char *, path);

_syscall3 (  off_t, lseek,  int, first, off_t, len, int, second);

_syscall2 (  int, lstat,  const char *, charbuf, struct Dummy *, dummy);

_syscall2 (  int, mkdir,  const char *, path, mode_t, mode);

_syscall3 (  int, mknod,  const char *, path, mode_t, mode, dev_t, dev);

_syscall2 (  int, mlock,  const void *, voidp, size_t, size);

_syscall1 (  int, mlockall,  int, first);


/*
_syscall1 (  long, mmap, unsigned long *, buffer);

__ptr_t __mmap (__ptr_t, size_t, int, int, int, off_t );

__ptr_t
__mmap(__ptr_t addr, size_t len, int prot, int flags, int fd, off_t off)
{
        unsigned long buffer[6];

        buffer[0] = (unsigned long)ulong1;
        buffer[1] = (unsigned long)ulong2;
        buffer[2] = (unsigned long)ulong3;
        buffer[3] = (unsigned long)ulong4;
        buffer[4] = (unsigned long)ulong5;
        buffer[5] = (unsigned long)ulong6;
        return (__ptr_t) _mmap(buffer);
}
*/


_syscall3 ( int, modify_ldt, int, first, void *, voidp, unsigned long,
	ulong1); 

_syscall5 ( int, mount, const char *, path, const char *, charbuf, const
	char *, charbuf2, unsigned long, ulong1 , const void *, voidp); 

_syscall3 (  int, mprotect,  const void *, voidp, size_t, size, int, second);

_syscall4 ( void *,  mremap, void *, voidp, size_t, size , size_t,
	size2, unsigned long, ulong1); 

_syscall3 (  int, msync,  const void *, voidp, size_t, size, int, first);

_syscall2 (  int, munlock,  const void *, voidp, size_t, size);

_syscall0 (  int, munlockall );

_syscall2 (  int, munmap,  void *, voidp , size_t, size);

_syscall2 ( int, nanosleep, const struct Dummy *, dummy, struct Dummy2
	*, dummy2);

_syscall3 (int, nfsservctl, int, first, struct Dummy *, dummy, union
	nfsctl_res *, dummy2); 

_syscall1 (  int, nice,  int, first);

_syscall3 (  int, open,  const char *, path, int, first, mode_t, mode);

_syscall0 (  int, pause );

_syscall1 (  int, personality,  unsigned long, ulong1);

_syscall1 (  int, pipe,  int, first);

_syscall3 ( int, poll, struct Dummy *, dummy, unsigned int, ufirst, int,
first); 

_syscall5 ( int, prctl, int, first, unsigned long, ulong1, unsigned long, 
	ulong2, unsigned long, ulong3, unsigned long, ulong4);

/*
pread
*/

_syscall4 ( int, ptrace, int, first, int, second, int, third, int,
	fourth);

/*
#define __NR_putpmsg            189    
#define __NR_pwrite             181
#define __NR_query_module       167
*/


_syscall4 ( int, quotactl , int, first, const char *, charbuf, int, second,
	caddr_t, addr); 

_syscall3 (  ssize_t, read,  int, fd, void *, voidp, size_t, size);

_syscall3 ( int, readdir, unsigned int, ufirst, struct Dummy *, dummy,
	unsigned int, usecond);

_syscall3 ( int, readlink, const char *, path, char *, charbuf, size_t,
	size); 

_syscall3 ( int, readv, int, first, const struct Dummy *, dummy, int,
	third); 

_syscall4 ( int, reboot , int, first, int, second, int, third, void *,
	voidp); 

_syscall2 (  int, rename,  const char *, path, const char *, charbuf);

_syscall1 (  int, rmdir,  const char *, path);

/*
#define __NR_rt_sigaction       174
#define __NR_rt_sigpending      176
#define __NR_rt_sigprocmask     175
#define __NR_rt_sigqueueinfo    178
#define __NR_rt_sigreturn       173
#define __NR_rt_sigsuspend      179
#define __NR_rt_sigtimedwait    177
*/

_syscall1 (  int, sched_get_priority_max,  int, first); 

_syscall1 (  int, sched_get_priority_min,  int, first); 

_syscall2 (  int, sched_rr_get_interval,  pid_t, pid, struct Dummy *, 
	dummy); 

_syscall2 (  int, sched_setparam,  pid_t, pid, const struct Dummy *, 
	dummy); 

_syscall2 (  int, sched_getparam,  pid_t, pid, struct Dummy *, 
	dummy); 

_syscall3 ( int, sched_setscheduler, pid_t, pid, int, first, const struct
	Dummy *, dummy);

_syscall1 (  int, sched_getscheduler,  pid_t, pid); 

_syscall0 (  int, sched_yield ); 

_syscall5 ( int, select, int, first, fd_set *, readfds , fd_set *, writefds,
	fd_set *, exceptfds, struct Dummy *, dummy);

/*
sendfile
setdomainname
*/

_syscall1 (  int, setfsgid,  uid_t, owner);

_syscall1 (  int, setfsuid,  uid_t, owner);

_syscall1 (  int, setgid,  gid_t, group);

_syscall2 (  int, setgroups,  size_t, size, const gid_t *, group);

_syscall2 (  int, sethostname,  const char *, name, size_t, len);

_syscall3 ( int, setitimer, int, first, const struct Dummy *, dummy,
	struct Dummy2 *, dummy2); 

_syscall2 (  int, setpgid,  pid_t, pid, pid_t, pid2);

/*
setpriority
*/

_syscall2 (  int, setregid,  gid_t, group, gid_t, group2);

_syscall3 (  int, setresuid,  uid_t, owner, uid_t, owner2, uid_t, owner3);

_syscall3 (  int, setresgid,  gid_t, group, gid_t, group2, gid_t, group3);

_syscall2 (  int, setreuid,  uid_t, owner, uid_t, owner2);

_syscall2 (  int, setrlimit ,  int, first, const struct Dummy *, dummy);


_syscall0 (  pid_t, setsid );

_syscall2 ( int, settimeofday, const struct Dummy *, dummy, const
	struct Dummy *, dummy2);

_syscall1 (  int, setuid,  uid_t, owner);

_syscall3 ( int, sigaction, int, first, const struct Dummy *, dummy,
	struct Dummy2 *, dummy2); 


/*
signal
*/

_syscall3 ( int, sigprocmask, int, first, const sigset_t *, dummy, sigset_t
	*, third); 

_syscall1 (  int, sigpending,  sigset_t *, set);

_syscall1 (  int, sigsuspend,  const sigset_t *, set);

_syscall1 (  int, sigreturn,  unsigned long, ulong1);

_syscall2 (  int, socketcall,  int, first, unsigned long *, ulong1);

_syscall2 (  int, stat,  const char *, charbuf, struct Dummy *, dummy);

_syscall2 (  int, statfs,  const char *, path, struct Dummy *, dummy);

_syscall2 (  int, fstatfs,  int, first, struct Dummy *, dummy);

_syscall1 (  int, stime,  time_t *, t);

_syscall2 (  int, swapon,  const char *, path, int, first);

_syscall1 (  int, swapoff,  const char *, path);

_syscall2 (  int, symlink,  const char *, path, const char *, charbuf);

_syscall0 (  int, sync );

_syscall1 (  int, _sysctl,  struct Dummy *, dummy);

_syscall3 (  int, sysfs,  int, first, unsigned int, ufirst, char *, charbuf);

_syscall1  ( int, sysinfo,  struct Dummy *, dummy);

_syscall3  ( int, syslog,  int, first, char *, charbuf, int, second);

_syscall1  ( time_t, time,  time_t *, t);

_syscall1  ( clock_t, times,  struct Dummy *, dummy);

_syscall2  ( int, truncate,  const char *, path, off_t, len);

_syscall1  ( mode_t, umask,  mode_t, mode);

_syscall1 (  int, umount,  const char *, path);

_syscall1  ( int, uname,  struct Dummy *, dummy);

_syscall1  ( int, unlink,  const char *, path);

_syscall1  ( int, uselib,  const char *, path);

_syscall2  ( int, ustat,  dev_t, dev, struct Dummy *, dummy);

_syscall2  ( int, utime,  const char *, path, struct Dummy *, dummy);

_syscall0  ( int, vhangup );

_syscall1  ( int, vm86old,  struct Dummy *, dummy);

_syscall2 ( int, vm86, unsigned long, ulong1, struct Dummy *,
	dummy); 

_syscall3  ( pid_t, waitpid,  pid_t, pid, int *, first, int, second);

_syscall4 ( pid_t, wait4, pid_t, pid, int *, first, int, second, struct
	Dummy *, dummy); 

_syscall3  ( size_t, write,  int, fd, const void *, voidp, size_t, size);

_syscall3  (  int, writev,  int, bletcherondo, const struct Dummy *, dummy, int, second);

